import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { SafeHtml } from '@angular/platform-browser';
import { Supplier, Transformer } from '@ui-model/common';
import { Toggle } from '@ui-model/core';
import { Subject } from 'rxjs/Subject';
import { Subscription } from 'rxjs/Subscription';
export declare class TypeAheadComponent<T extends {
    format?: Supplier<SafeHtml>;
    parse?: Supplier<string>;
}> implements ControlValueAccessor, OnInit, OnDestroy {
    dropDown: Toggle;
    checker: Subject<{}>;
    items: T[];
    displayField: string;
    placeholder: string;
    valueField: string;
    formatter: Transformer<any, SafeHtml>;
    parser: Transformer<any, string>;
    search: EventEmitter<string>;
    activeIndex: number;
    defaultFormatter(value: T): string | SafeHtml;
    defaultParser(value: T): string;
    sub: Subscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    term: string;
    _value: T;
    value: T;
    _change: (value: T) => void;
    _touched: () => void;
    protected changed(): void;
    writeValue(value: T): void;
    registerOnChange(fn: (value: T) => void): void;
    registerOnTouched(fn: () => void): void;
    disabled: boolean;
    setDisabledState(isDisabled: boolean): void;
    select(item: T): void;
    clear(): void;
    keydown($event: KeyboardEvent): void;
    keyup($event: KeyboardEvent): void;
    keypress($event: KeyboardEvent): void;
}
